/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief USBҰ
//!
//!  ̧ق͋Lqq\ʂĉpBɎʂUSBҰ܂݂܂B
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! - x޲	: ATmega32U4
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

//_____ ݸٰ ____________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "lib_mcu/usb/usb_drv.h"
#include "usb_descriptors.h"
#include "modules/usb/device_chap9/usb_standard_request.h"
#include "usb_specific_request.h"
#if ((USB_DEVICE_SN_USE==ENABLE) && (USE_DEVICE_SN_UNIQUE==ENABLE))
  #include "lib_mcu/flash/flash_drv.h"
#endif

//_____ ϸ ________________________________________________________________

//_____ ` _______________________________________________________________

// usb_user_device_descriptor
code S_usb_device_descriptor usb_dev_desc =
{
	sizeof(usb_dev_desc),
	DESCRIPTOR_DEVICE,
	Usb_write_word_enum_struc(USB_SPECIFICATION),
	DEVICE_CLASS,
	DEVICE_SUB_CLASS,
	DEVICE_PROTOCOL,
	EP_CONTROL_LENGTH,
	Usb_write_word_enum_struc(VENDOR_ID),
	Usb_write_word_enum_struc(PRODUCT_ID),
	Usb_write_word_enum_struc(RELEASE_NUMBER),
	MAN_INDEX,
	PROD_INDEX,
	SN_INDEX,
	NB_CONFIGURATION
};

// usb_user_configuration_descriptor FS
code S_usb_user_configuration_descriptor usb_conf_desc =
{
	{
		sizeof(S_usb_configuration_descriptor),
		DESCRIPTOR_CONFIGURATION,
		Usb_write_word_enum_struc(sizeof(S_usb_user_configuration_descriptor)),
		NB_INTERFACE,
		CONF_NB,
		CONF_INDEX,
		CONF_ATTRIBUTES,
		MAX_POWER
	},
	//** ŏ̲̪͐䉹̪łB
	// AudioControl(AC)̪Lqq͑Ή鉹@\Sɓt֘A܂݂܂B
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		AC_INTERFACE_NB,
		AC_ALTERNATE,
		AC_NB_ENDPOINT,
		AC_INTERFACE_CLASS,
		AC_INTERFACE_SUB_CLASS,
		AC_INTERFACE_PROTOCOL,
		AC_INTERFACE_INDEX
	},
	// ׽LAC̪Lqq
	{
		sizeof(S_usb_ac_interface_descriptor),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AC_HEADER,
		Usb_write_word_enum_struc(AUDIO_CLASS_REVISION),
		Usb_write_word_enum_struc(sizeof(S_usb_ac_interface_descriptor)\
								 +sizeof(S_usb_in_ter_descriptor)+sizeof(S_usb_feature_unit_descriptor_speaker)+sizeof(S_usb_out_ter_descriptor)\
								 +sizeof(S_usb_in_ter_descriptor)+sizeof(S_usb_feature_unit_descriptor_micro)+sizeof(S_usb_out_ter_descriptor)),
		NB_OF_STREAMING_INTERFACE,
		STD_AS_IN_INTERFACE_NB,
		STD_AS_OUT_INTERFACE_NB
	},
	//* gpLqq
	// ׽L͒[qLqq
	{
		sizeof(S_usb_in_ter_descriptor),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AC_INPUT_TERMINAL,
		SPEAKER_INPUT_TERMINAL_ID,
		Usb_write_word_enum_struc(SPEAKER_INPUT_TERMINAL_TYPE),
		SPEAKER_INPUT_TERMINAL_ASSOCIATION,
		SPEAKER_INPUT_TERMINAL_NB_CHANNELS,
		SPEAKER_INPUT_TERMINAL_CHANNEL_CONF,
		SPEAKER_INPUT_TERMINAL_CH_NAME_ID,
		SPEAKER_INPUT_TERMINAL_NAME_ID
	},
	// ׽L@\Lqq
	{
		sizeof(S_usb_feature_unit_descriptor_speaker),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AC_FEATURE_UNIT,
		SPEAKER_FEATURE_UNIT_ID,
		SPEAKER_FEATURE_UNIT_SOURCE_ID,
		0x01,
		SPEAKER_FEATURE_UNIT_CTRL_CH_MASTER,
		SPEAKER_FEATURE_UNIT_CTRL_CH_1
	},
	// ׽Lo͒[qLqq
	{
		sizeof(S_usb_out_ter_descriptor),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AC_OUTPUT_TERMINAL,
		SPEAKER_OUTPUT_TERMINAL_ID,
		Usb_write_word_enum_struc(SPEAKER_OUTPUT_TERMINAL_TYPE),
		SPEAKER_OUTPUT_TERMINAL_ASSOCIATION,
		SPEAKER_OUTPUT_TERMINAL_SOURCE_ID,
		SPEAKER_OUTPUT_TERMINAL_NAME_ID
	},
	//* ϲ̫ݗpLqq
	// ׽L͒[qLqq
	{
		sizeof(S_usb_in_ter_descriptor),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AC_INPUT_TERMINAL,
		MICRO_INPUT_TERMINAL_ID,
		Usb_write_word_enum_struc(MICRO_INPUT_TERMINAL_TYPE),
		MICRO_INPUT_TERMINAL_ASSOCIATION,
		MICRO_INPUT_TERMINAL_NB_CHANNELS,
		MICRO_INPUT_TERMINAL_CHANNEL_CONF,
		MICRO_INPUT_TERMINAL_CH_NAME_ID,
		MICRO_INPUT_TERMINAL_NAME_ID
	},
	// ׽L@\Lqq
	{
		sizeof(S_usb_feature_unit_descriptor_micro),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AC_FEATURE_UNIT,
		MICRO_FEATURE_UNIT_ID,
		MICRO_FEATURE_UNIT_SOURCE_ID,
		0x01,
		MICRO_FEATURE_UNIT_CTRL_CH_MASTER,
		MICRO_FEATURE_UNIT_CTRL_CH_1
	},
	// ׽Lo͒[qLqq
	{
		sizeof(S_usb_out_ter_descriptor),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AC_OUTPUT_TERMINAL,
		MICRO_OUTPUT_TERMINAL_ID,
		Usb_write_word_enum_struc(MICRO_OUTPUT_TERMINAL_TYPE),
		MICRO_OUTPUT_TERMINAL_ASSOCIATION,
		MICRO_OUTPUT_TERMINAL_SOURCE_ID,
		MICRO_OUTPUT_TERMINAL_NAME_ID
	},
	//** 2ڂ̲̪(2ֲ̪̑)gp̪łB
	// WAS̪Lqq(߲ĂȂ0)
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		STD_AS_OUT_INTERFACE_NB,
		ALT0_AS_OUT_INTERFACE_INDEX,
		ALT0_AS_OUT_NB_ENDPOINT,
		ALT0_AS_OUT_INTERFACE_CLASS,
		ALT0_AS_OUT_INTERFACE_SUB_CLASS,
		ALT0_AS_OUT_INTERFACE_PROTOCOL,
		0x00
	},
	// WAS̪Lqq(1̴߲Ă1)
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		STD_AS_OUT_INTERFACE_NB,
		ALT1_AS_OUT_INTERFACE_INDEX,
		ALT1_AS_OUT_NB_ENDPOINT,
		ALT1_AS_OUT_INTERFACE_CLASS,
		ALT1_AS_OUT_INTERFACE_SUB_CLASS,
		ALT1_AS_OUT_INTERFACE_PROTOCOL,
		0x00
	},
	// ׽LAS̪Lqq
	{
		sizeof(S_usb_as_interface_descriptor),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AS_GENERAL,
		AS_OUT_TERMINAL_LINK,
		AS_OUT_DELAY,
		Usb_write_word_enum_struc(AS_OUT_FORMAT_TAG)
	},
	{
		sizeof(S_usb_format_type),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AS_FORMAT_TYPE,
		OUT_FORMAT_TYPE,
		OUT_FORMAT_NB_CHANNELS,
		OUT_FORMAT_FRAME_SIZE,
		OUT_FORMAT_BIT_RESOLUTION,
		OUT_FORMAT_SAMPLE_FREQ_NB,
		Usb_write_word_enum_struc(OUT_FORMAT_LSBYTE_SAMPLE_FREQ),
		OUT_FORMAT_MSBYTE_SAMPLE_FREQ
	},
	{
		sizeof(S_usb_endpoint_audio_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_OUT,
		EP_ATTRIBUTES_OUT,
		Usb_write_word_enum_struc(EP_SIZE_OUT),
		EP_INTERVAL_OUT,
		0x00,
		0x00
	},
	{
		sizeof(S_usb_endpoint_audio_specific),
		DESCRIPTOR_AUDIO_ENDPOINT,
		DESCRIPTOR_SUBTYPE_AUDIO_ENDP_GENERAL,
		AUDIO_EP_OUT_ATRIBUTES,
		AUDIO_EP_OUT_DELAY_UNIT,
		Usb_write_word_enum_struc(AUDIO_EP_OUT_LOCK_DELAY)
	},
	//** 3ڂ̲̪(2ֲ̪̑)ϲ̫ݗp̪łB
	// WAS̪Lqq(߲ĂȂ0)
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		STD_AS_IN_INTERFACE_NB,
		ALT0_AS_IN_INTERFACE_INDEX,
		ALT0_AS_IN_NB_ENDPOINT,
		ALT0_AS_IN_INTERFACE_CLASS,
		ALT0_AS_IN_INTERFACE_SUB_CLASS,
		ALT0_AS_IN_INTERFACE_PROTOCOL,
		0x00
	},
	// WAS̪Lqq(1̴߲Ă1)
	{
		sizeof(S_usb_interface_descriptor),
		DESCRIPTOR_INTERFACE,
		STD_AS_IN_INTERFACE_NB,
		ALT1_AS_IN_INTERFACE_INDEX,
		ALT1_AS_IN_NB_ENDPOINT,
		ALT1_AS_IN_INTERFACE_CLASS,
		ALT1_AS_IN_INTERFACE_SUB_CLASS,
		ALT1_AS_IN_INTERFACE_PROTOCOL,
		0x00
	},
	// ׽LAS̪Lqq
	{
		sizeof(S_usb_as_interface_descriptor),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AS_GENERAL,
		AS_IN_TERMINAL_LINK,
		AS_IN_DELAY,
		Usb_write_word_enum_struc(AS_IN_FORMAT_TAG)
	},
	{
		sizeof(S_usb_format_type),
		DESCRIPTOR_AUDIO_INTERFACE,
		DESCRIPTOR_SUBTYPE_AUDIO_AS_FORMAT_TYPE,
		IN_FORMAT_TYPE,
		IN_FORMAT_NB_CHANNELS,
		IN_FORMAT_FRAME_SIZE,
		IN_FORMAT_BIT_RESOLUTION,
		IN_FORMAT_SAMPLE_FREQ_NB,
		Usb_write_word_enum_struc(IN_FORMAT_LSBYTE_SAMPLE_FREQ),
		IN_FORMAT_MSBYTE_SAMPLE_FREQ
	},
	{
		sizeof(S_usb_endpoint_audio_descriptor),
		DESCRIPTOR_ENDPOINT,
		ENDPOINT_NB_IN,
		EP_ATTRIBUTES_IN,
		Usb_write_word_enum_struc(EP_SIZE_IN),
		EP_INTERVAL_IN,
		0x00,
		0x00
	},
	{
		sizeof(S_usb_endpoint_audio_specific),
		DESCRIPTOR_AUDIO_ENDPOINT,
		DESCRIPTOR_SUBTYPE_AUDIO_ENDP_GENERAL,
		AUDIO_EP_IN_ATRIBUTES,
		AUDIO_EP_IN_DELAY_UNIT,
		Usb_write_word_enum_struc(AUDIO_EP_IN_LOCK_DELAY)
	}
};

// usb_user_manufacturer_string_descriptor
code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor =
{
	sizeof(usb_user_manufacturer_string_descriptor),
	DESCRIPTOR_STRING,
	USB_MANUFACTURER_NAME
};

// usb_user_product_string_descriptor
code S_usb_product_string_descriptor usb_user_product_string_descriptor =
{
	sizeof(usb_user_product_string_descriptor),
	DESCRIPTOR_STRING,
	USB_PRODUCT_NAME
};

// usb_user_serial_number
#if (USB_DEVICE_SN_USE==ENABLE)
code S_usb_serial_number usb_user_serial_number =
{
  #if (USE_DEVICE_SN_UNIQUE==ENABLE)
	sizeof(usb_user_serial_number)+4*SN_LENGTH,
	DESCRIPTOR_STRING
  #else
	sizeof(usb_user_serial_number),
	DESCRIPTOR_STRING,
	USB_SERIAL_NUMBER
  #endif
};
#endif

// usb_user_language_id
code S_usb_language_id usb_user_language_id =
{
	sizeof(usb_user_language_id),
	DESCRIPTOR_STRING,
	Usb_write_word_enum_struc(LANGUAGE_ID)
};
